<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>CurrentVoting</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/operation/current-voting-service.ts</code>
        </p>





            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#birthDateScope">birthDateScope</a>
                            </li>
                            <li>
                                    <span class="modifier">Optional</span>
                                <a href="#elections">elections</a>
                            </li>
                            <li>
                                    <span class="modifier">Optional</span>
                                <a href="#finalizationLog">finalizationLog</a>
                            </li>
                            <li>
                                <a href="#lastVisited">lastVisited</a>
                            </li>
                            <li>
                                <a href="#operation">operation</a>
                            </li>
                            <li>
                                    <span class="modifier">Optional</span>
                                <a href="#votations">votations</a>
                            </li>
                        </ul>
                    </td>
                </tr>






        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(operation: <a href="../interfaces/Operation.html">Operation</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="43" class="link-to-prism">src/app/operation/current-voting-service.ts:43</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>operation</td>
                                                  
                                                        <td>
                                                                    <code><a href="../interfaces/Operation.html" target="_self" >Operation</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="birthDateScope"></a>
                        <span class="name">
                            <b>
                            birthDateScope
                            </b>
                            <a href="#birthDateScope"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>birthDateScope:     <code>&quot;DAY&quot; | &quot;MONTH&quot; | &quot;YEAR&quot;</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>&quot;DAY&quot; | &quot;MONTH&quot; | &quot;YEAR&quot;</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="42" class="link-to-prism">src/app/operation/current-voting-service.ts:42</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="elections"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Optional</span>
                            elections
                            </b>
                            <a href="#elections"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>elections:     <code><a href="../interfaces/ElectionBallot.html" target="_self" >ElectionBallot[]</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../interfaces/ElectionBallot.html" target="_self" >ElectionBallot[]</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="40" class="link-to-prism">src/app/operation/current-voting-service.ts:40</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="finalizationLog"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Optional</span>
                            finalizationLog
                            </b>
                            <a href="#finalizationLog"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>finalizationLog:     <code><a href="../interfaces/FinalizationLogData.html" target="_self" >FinalizationLogData</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../interfaces/FinalizationLogData.html" target="_self" >FinalizationLogData</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="41" class="link-to-prism">src/app/operation/current-voting-service.ts:41</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="lastVisited"></a>
                        <span class="name">
                            <b>
                            lastVisited
                            </b>
                            <a href="#lastVisited"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>lastVisited:     <code><a href="../miscellaneous/typealiases.html#Page" target="_self" >Page</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../miscellaneous/typealiases.html#Page" target="_self" >Page</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="43" class="link-to-prism">src/app/operation/current-voting-service.ts:43</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="operation"></a>
                        <span class="name">
                            <b>
                            operation
                            </b>
                            <a href="#operation"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>operation:     <code><a href="../interfaces/Operation.html" target="_self" >Operation</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../interfaces/Operation.html" target="_self" >Operation</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="38" class="link-to-prism">src/app/operation/current-voting-service.ts:38</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="votations"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Optional</span>
                            votations
                            </b>
                            <a href="#votations"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>votations:     <code><a href="../interfaces/Votation.html" target="_self" >Votation[]</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../interfaces/Votation.html" target="_self" >Votation[]</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="39" class="link-to-prism">src/app/operation/current-voting-service.ts:39</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>







    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Injectable } from &#x27;@angular/core&#x27;;
import { Operation } from &#x27;../model/operation&#x27;;
import { tap } from &#x27;rxjs/operators&#x27;;
import { Observable, of, ReplaySubject } from &#x27;rxjs&#x27;;
import { OperationService } from &#x27;./operation.service&#x27;;
import { VoterOperationData } from &#x27;../model/voter-operation-data&#x27;;
import { ElectionBallot } from &#x27;../model/election&#x27;;
import { Subject, Votation } from &#x27;../model/votation&#x27;;
import { isVotationBallot } from &#x27;../model/ballot&#x27;;
import { FinalizationLogData } from &#x27;../model/finalization-log-data&#x27;;

type Page &#x3D; &#x27;IDENTIFICATION&#x27; | &#x27;LEGAL_INFORMATION&#x27; | &#x27;BALLOT_SELECTION&#x27; | &#x27;SUMMARY&#x27; | &#x27;CONTROL&#x27; | &#x27;FINALIZATION&#x27;;

export class CurrentVoting {
  operation: Operation;
  votations?: Votation[];
  elections?: ElectionBallot[];
  finalizationLog?: FinalizationLogData;
  birthDateScope: &#x27;DAY&#x27; | &#x27;MONTH&#x27; | &#x27;YEAR&#x27;;
  lastVisited: Page;

  constructor(operation: Operation) {
    this.operation &#x3D; operation;
  }
}

/**
 * This class contains all elements concerning a current voting process.
 */
@Injectable()
export class CurrentVotingService {

  private _currentVoting: CurrentVoting;
  currentVotingChange &#x3D; new ReplaySubject&lt;CurrentVoting&gt;(1);

  constructor(private operationService: OperationService) {
    let currentVotingJson &#x3D; sessionStorage.getItem(&quot;current-voting&quot;);
    if (currentVotingJson) {
      this._currentVoting &#x3D; JSON.parse(currentVotingJson);
    }
  }

  get operation() {
    return this._currentVoting.operation;
  }

  get votations(): Votation[] {
    return this._currentVoting.votations;
  }

  get birthDateScope() {
    return this._currentVoting.birthDateScope;
  }

  get elections() {
    return this._currentVoting.elections;
  }

  get finalizationLog(): FinalizationLogData {
    return this._currentVoting.finalizationLog;
  }

  get lastVisitedPage(): Page {
    return this._currentVoting.lastVisited;
  }

  set lastVisitedPage(page: Page) {
    this._currentVoting.lastVisited &#x3D; page;
  }

  getOperationInstance(instanceId: string): Observable&lt;Operation&gt; {
    if (this._currentVoting &amp;&amp; this._currentVoting.operation.protocolInstanceId &#x3D;&#x3D;&#x3D; instanceId) {
      return of(this._currentVoting.operation);
    }

    return this.operationService.getOperation(instanceId).pipe(
      tap(operation &#x3D;&gt; {
        this._currentVoting &#x3D; new CurrentVoting(operation);
        this.notifyChange();
      })
    );
  }

  attachVoterOperationData(voterOperationData: VoterOperationData) {
    this._currentVoting.votations &#x3D; voterOperationData.votations;
    this._currentVoting.elections &#x3D; voterOperationData.elections;
    this._currentVoting.birthDateScope &#x3D; voterOperationData.birthDateScope;
    this.notifyChange();
  }

  attachFinalizationLogData(finalizationLogData: FinalizationLogData) {
    this._currentVoting.finalizationLog &#x3D; finalizationLogData;
    this.notifyChange();
  }

  private notifyChange() {
    sessionStorage.setItem(&quot;current-voting&quot;, JSON.stringify(this._currentVoting));
    this.currentVotingChange.next(this._currentVoting);
  }

  // TODO: rework this function to respect subjects repository ordering
  private static getAllSubjects(votations: Votation[]): Subject[] {
    let subjects: Subject[] &#x3D; [];
    votations.forEach(votation &#x3D;&gt; {
      votation.variantSubjects.forEach(variantSubject &#x3D;&gt; {
        subjects &#x3D; subjects.concat(variantSubject.subjects).concat(variantSubject.tieBreak);
      });
      subjects &#x3D; subjects.concat(votation.subjects);
    });
    return subjects;
  }

  static initVotationBallot(votations: Votation[]): void {
    this.getAllSubjects(votations).forEach(subject &#x3D;&gt; {
      subject.bufferedAnswer &#x3D; subject.answers.find(answer &#x3D;&gt; answer.virtual);
    });
  }

  static copyVotationBallotInBuffer(votations: Votation[]): void {
    this.getAllSubjects(votations).forEach(subject &#x3D;&gt; {
      subject.bufferedAnswer &#x3D; subject.selectedAnswer;
    });
  }

  static hasVotingBallotChanged(votations: Votation[]): boolean {
    for (let subject of this.getAllSubjects(votations)) {
      if ((subject.selectedAnswer &#x3D;&#x3D;&#x3D; undefined &amp;&amp; subject.bufferedAnswer !&#x3D;&#x3D;
           subject.answers.find(answer &#x3D;&gt; answer.virtual)) ||
          (subject.selectedAnswer !&#x3D;&#x3D; undefined &amp;&amp; subject.selectedAnswer !&#x3D;&#x3D; subject.bufferedAnswer)) {
        return true
      }
    }
    return false;
  }

  static commitVotationBallot(votations: Votation[]): void {
    this.getAllSubjects(votations).forEach(subject &#x3D;&gt; {
      subject.selectedAnswer &#x3D; subject.bufferedAnswer;
      subject.bufferedAnswer &#x3D; undefined;
    });
  }

  hasSingleBallot(): boolean {
    return (this.operation.groupVotation &amp;&amp; this.elections.length &#x3D;&#x3D;&#x3D; 0) ||
           (this.votations.length + this.elections.length &#x3D;&#x3D;&#x3D; 1)
  }

  hasVotedFor(ballot: Votation | ElectionBallot) {
    if (isVotationBallot(ballot)) {
      return CurrentVotingService.getAllSubjects([ballot]).some(subject &#x3D;&gt; subject.selectedAnswer !&#x3D;&#x3D; undefined);
    }
    return ballot.elections.every(election &#x3D;&gt;
      election.candidates.some(candidate &#x3D;&gt; candidate.isSelected)
    );
  }

  participationCount(): number {
    let counter &#x3D; 0;
    for (let ballot of this.votations) {
      if (this.hasVotedFor(ballot)) {
        counter++;
      }
    }
    for (let ballot of this.elections) {
      if (this.hasVotedFor(ballot)) {
        counter++;
      }
    }
    return counter;
  }

  removeVoteFor(ballot: Votation | ElectionBallot) {
    if (isVotationBallot(ballot)) {
      CurrentVotingService.getAllSubjects([ballot]).forEach(subject &#x3D;&gt; {
        subject.selectedAnswer &#x3D; undefined
      });
    } else {
      ballot.elections.forEach(election &#x3D;&gt;
        election.candidates.forEach(candidate &#x3D;&gt; candidate.isSelected &#x3D; false)
      );
    }
    this.notifyChange();
  }

  buildSelection(): number[] {
    let selections &#x3D; [];

    // TODO: add election selections
    // votation selections
    CurrentVotingService.getAllSubjects(this.votations).forEach(subject &#x3D;&gt; {
      selections.push(subject.selectedAnswer.protocolIndex);
    });

    return selections;
  }

  populateVerificationCodes(verificationCodes: string[]): void {
    let index: number &#x3D; 0;
    // TODO: populate elections
    CurrentVotingService.getAllSubjects(this.votations).forEach(subject &#x3D;&gt; {
      subject.selectedAnswer.verificationCode &#x3D; verificationCodes[index++];
    });
  }

  computeSubjectIndex(seekSubject: Subject): string {
    let ballotIndex: number &#x3D; 0;
    for (let votation of this.votations) {
      ballotIndex++;
      let subjectIndex: number &#x3D; 0;
      for (let subject of CurrentVotingService.getAllSubjects([votation])) {
        subjectIndex++;
        if (subject &#x3D;&#x3D;&#x3D; seekSubject) {
          return &#x60;${ballotIndex}-${subjectIndex}&#x60;;
        }
      }
    }
    return &#x27;unknown&#x27;;
  }
}
</code></pre>
    </div>
</div>







                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'CurrentVoting.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
